<template>
  <div class="page-body">
    <div class="page-search row items-center">
      <div class="col row wrap q-mr-lg q-col-gutter-md">
        <div class="col-3">
          <q-input @input="resetSearch" clearable filled v-model="msg.LessonName" label="课程名称" @clear="resetSearch"
            maxlength="30" />
        </div>
      </div>
    </div>
    <div class="page-content">
      <q-table :pagination="msg" :loading="loading" no-data-label="暂无相关数据" flat
        class="sticky-column-table" separator="none" :data="dataList" :columns="columns" row-key="name">
        <template v-slot:top>
          <div class="col-2 q-table__title">试听课程管理</div>
          <q-space />
          <div class="page-option">
            <q-btn color="accent" size="sm" class="q-mr-md" icon="add" label="新增试听课程" @click="addObj(null)" />
          </div>
        </template>
        <template v-slot:body-cell-CalculateType="props">
          <q-td>
            {{props.row.CalculateType==1?'单次':'按月'}}
          </q-td>
        </template>
        <template v-slot:bottom>
          <q-pagination class="full-width justify-end" v-model="msg.PageIndex" color="primary" :max="pageCount"
            :input="true" @input="changePage" />
        </template>
        <template v-slot:body-cell-Id="props">
          <q-td :props="props">
            <div>
              <q-btn flat size="xs" icon="edit" color="accent" style="font-weight:400" label="编辑"
                @click="addObj(props.row)" />
              <q-btn flat size="xs" icon="delete" color="negative" class="q-mr-xs" label="删除"
                @click="deleteCustom(props.row.Id)" />
            </div>
          </q-td>
        </template>
      </q-table>
    </div>
    <listen-form v-if="isShowListenForm" :save-obj="customObj" @close="closeListenForm" @success="refreshPage">
    </listen-form>
  </div>
</template>

<script>
  import {
    GetTrialLessonPage,
    RemoveTrialLesson
  } from '../../api/course/index'
  import listenForm from '../../components/course/listen-form'
  export default {
    meta: {
      title: "试听课程管理"
    },
    components: {
      listenForm
    },
    data() {
      return {
        columns: [{
            name: 'LessonName',
            label: '试听课程名称',
            field: 'LessonName',
            align: 'left'
          },
          {
            name: 'TeacherName',
            label: '试听课主讲老师',
            align: 'left',
            field: 'TeacherName'
          }, {
            name: 'ClassHourFee',
            label: '课时费',
            align: 'left',
            field: 'ClassHourFee'
          }, {
            name: 'CalculateType',
            label: '核算方式',
            align: 'left',
            field: 'CalculateType'
          },
          {
            name: 'CreateByName',
            label: '创建人',
            align: 'left',
            field: 'CreateByName'
          },
          {
            name: 'CreateTimeStr',
            label: '创建时间',
            align: 'left',
            field: 'CreateTimeStr'
          },
           {
            name: 'Id',
            label: '操作',
            field: 'Id'
          }
        ],
        msg: {
          PageIndex: 1,
          pageSize: 12,
          rowsPerPage: 12,
          LessonName: ""
        },
        dataList: [],
        loading: true,
        isShowListenForm: false,
        customObj: {},
        pageCount: 0
      }
    },
    mounted() {
      this.getList()
    },
    methods: {
      resetSearch() {
        this.msg.PageIndex = 1;
        this.getList();
      },
      changePage(val) {
        this.msg.PageIndex = val;
        this.getList();
      },
      //删除
      deleteCustom(Id) {
        let delMsg = {
          Id: Id
        };
        this.$q.dialog({
          title: '提示信息',
          message: '是否确定删除该试听课？',
          cancel: true,
          persistent: true,
          ok: "确定",
          cancel: "取消",
        }).onOk(() => {
          RemoveTrialLesson(delMsg).then(res => {
            if (res.Code == 1) {
              this.$q.notify({
                icon: 'iconfont icon-chenggong',
                color: 'accent',
                timeout: 2000,
                message: '删除成功！',
                position: 'top'
              })
              this.getList();
            }
          })
        }).onCancel(() => {

        });
      },
      getList() {
        this.loading = true;
        GetTrialLessonPage(this.msg).then(res => {
          this.loading = false;
          if (res.Code == 1) {
            this.dataList = res.Data.PageData;
            this.pageCount = res.Data.PageCount;
          }
        })
      },
      closeListenForm() {
        this.isShowListenForm = false
      },
      refreshPage() {
        this.getList();
      },
      addObj(obj) {
        if (obj) {
          this.customObj = obj
        } else {
          this.customObj = null
        }
        this.isShowListenForm = true;
      }
    },
  }
</script>

<style lang="sass">
  @import url('~assets/css/table.sass')
</style>